std::unique_ptr< _Tp[], _Dp > Class Template Reference
Utilities » Memory » Pointer Abstractions

## Public Types

template<typename _Up >
using | __safe_conversion_raw = __and_< __or_< __or_< is_same< _Up, pointer >, is_same< _Up, nullptr_t > >, __and_< is_pointer< _Up >, is_same< pointer, element_type * >, is_convertible< typename remove_pointer< _Up >::type(*)[], element_type(*)[]> > > >
template<typename _Up , typename _Ep , typename _UPtr = unique_ptr<_Up, _Ep>, typename _UP_pointer = typename _UPtr::pointer, typename _UP_element_type = typename _UPtr::element_type>
using | __safe_conversion_up = __and_< is_array< _Up >, is_same< pointer, element_type * >, is_same< _UP_pointer, _UP_element_type * >, is_convertible< _UP_element_type(*)[], element_type(*)[]> >
using | deleter_type = _Dp
using | element_type = _Tp
using | pointer = typename __uniq_ptr_impl< _Tp, _Dp >::pointer

## Public Member Functions

template<typename _Up = _Dp, typename = _DeleterConstraint<_Up>>
constexpr | unique_ptr () noexcept
template<typename _Up , typename _Vp = _Dp, typename = _DeleterConstraint<_Vp>, typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>
| unique_ptr (_Up __p) noexcept
template<typename _Up , typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>
| unique_ptr (_Up __p, typename conditional< is_reference< deleter_type >::value, deleter_type, const deleter_type & >::type __d) noexcept
template<typename _Up , typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>
| unique_ptr (_Up __p, typename remove_reference< deleter_type >::type &&__d) noexcept
| unique_ptr (const unique_ptr &)=delete
template<typename _Up = _Dp, typename = _DeleterConstraint<_Up>>
constexpr | unique_ptr (nullptr_t) noexcept
| unique_ptr (unique_ptr &&__u) noexcept
template<typename _Up , typename _Ep , typename = _Require< __safe_conversion_up<_Up, _Ep>, typename conditional<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>::type>>
| unique_ptr (unique_ptr< _Up, _Ep > &&__u) noexcept
| ~unique_ptr ()
pointer | get () const noexcept
const deleter_type & | get_deleter () const noexcept
deleter_type & | get_deleter () noexcept
| operator bool () const noexcept
unique_ptr & | operator= (const unique_ptr &)=delete
unique_ptr & | operator= (nullptr_t) noexcept
unique_ptr & | operator= (unique_ptr &&__u) noexcept
template<typename _Up , typename _Ep >
enable_if< __and_< __safe_conversion_up< _Up, _Ep >, is_assignable< deleter_type &, _Ep && > >::value, unique_ptr & >::type | operator= (unique_ptr< _Up, _Ep > &&__u) noexcept
std::add_lvalue_reference< element_type >::type | operator[] (size_t __i) const
pointer | release () noexcept
template<typename _Up , typename = _Require< __or_<is_same<_Up, pointer>, __and_<is_same<pointer, element_type*>, is_pointer<_Up>, is_convertible< typename remove_pointer<_Up>::type(*)[], element_type(*)[] > > > >>
void | reset (_Up __p) noexcept
void | reset (nullptr_t=nullptr) noexcept
void | swap (unique_ptr &__u) noexcept

## Detailed Description

### template<typename _Tp, typename _Dp>
class std::unique_ptr< _Tp[], _Dp >

20.7.1.3 unique_ptr for array objects with a runtime length

Definition at line 406 of file unique_ptr.h.

The documentation for this class was generated from the following file:

- unique_ptr.h